// Code generated by gobind. DO NOT EDIT.

// Java class org.ethereum.geth.EthereumClient is a proxy for talking to a Go program.
//
//   autogenerated by gobind -lang=java -javapkg=org.ethereum github.com/ethereum/go-ethereum/mobile
package org.ethereum.geth;

import go.Seq;

/**
 * EthereumClient provides access to the Ethereum APIs.
 */
public final class EthereumClient implements Seq.Proxy {
	static { Geth.touch(); }
	
	private final int refnum;
	
	@Override public final int incRefnum() {
	      Seq.incGoRef(refnum, this);
	      return refnum;
	}
	
	/**
	 * NewEthereumClient connects a client to the given URL.
	 */
	public EthereumClient(String rawurl) {
		this.refnum = __NewEthereumClient(rawurl);
		Seq.trackGoRef(refnum, this);
	}
	
	private static native int __NewEthereumClient(String rawurl);
	
	EthereumClient(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
	
	/**
	 * CallContract executes a message call transaction, which is directly executed in the VM
	of the node, but never mined into the blockchain.
	
	blockNumber selects the block height at which the call runs. It can be &lt;0, in which
	case the code is taken from the latest known block. Note that state from very old
	blocks might not be available.
	 */
	public native byte[] callContract(Context ctx, CallMsg msg, long number) throws Exception;
	/**
	 * EstimateGas tries to estimate the gas needed to execute a specific transaction based on
	the current pending state of the backend blockchain. There is no guarantee that this is
	the true gas limit requirement as other transactions may be added or removed by miners,
	but it should provide a basis for setting a reasonable default.
	 */
	public native long estimateGas(Context ctx, CallMsg msg) throws Exception;
	/**
	 * FilterLogs executes a filter query.
	 */
	public native Logs filterLogs(Context ctx, FilterQuery query) throws Exception;
	/**
	 * GetBalanceAt returns the wei balance of the given account.
	The block number can be &lt;0, in which case the balance is taken from the latest known block.
	 */
	public native BigInt getBalanceAt(Context ctx, Address account, long number) throws Exception;
	/**
	 * GetBlockByHash returns the given full block.
	 */
	public native Block getBlockByHash(Context ctx, Hash hash) throws Exception;
	/**
	 * GetBlockByNumber returns a block from the current canonical chain. If number is &lt;0, the
	latest known block is returned.
	 */
	public native Block getBlockByNumber(Context ctx, long number) throws Exception;
	/**
	 * GetCodeAt returns the contract code of the given account.
	The block number can be &lt;0, in which case the code is taken from the latest known block.
	 */
	public native byte[] getCodeAt(Context ctx, Address account, long number) throws Exception;
	/**
	 * GetHeaderByHash returns the block header with the given hash.
	 */
	public native Header getHeaderByHash(Context ctx, Hash hash) throws Exception;
	/**
	 * GetHeaderByNumber returns a block header from the current canonical chain. If number is &lt;0,
	the latest known header is returned.
	 */
	public native Header getHeaderByNumber(Context ctx, long number) throws Exception;
	/**
	 * GetNonceAt returns the account nonce of the given account.
	The block number can be &lt;0, in which case the nonce is taken from the latest known block.
	 */
	public native long getNonceAt(Context ctx, Address account, long number) throws Exception;
	/**
	 * GetPendingBalanceAt returns the wei balance of the given account in the pending state.
	 */
	public native BigInt getPendingBalanceAt(Context ctx, Address account) throws Exception;
	/**
	 * GetPendingCodeAt returns the contract code of the given account in the pending state.
	 */
	public native byte[] getPendingCodeAt(Context ctx, Address account) throws Exception;
	/**
	 * GetPendingNonceAt returns the account nonce of the given account in the pending state.
	This is the nonce that should be used for the next transaction.
	 */
	public native long getPendingNonceAt(Context ctx, Address account) throws Exception;
	/**
	 * GetPendingStorageAt returns the value of key in the contract storage of the given account in the pending state.
	 */
	public native byte[] getPendingStorageAt(Context ctx, Address account, Hash key) throws Exception;
	/**
	 * GetPendingTransactionCount returns the total number of transactions in the pending state.
	 */
	public native long getPendingTransactionCount(Context ctx) throws Exception;
	/**
	 * GetStorageAt returns the value of key in the contract storage of the given account.
	The block number can be &lt;0, in which case the value is taken from the latest known block.
	 */
	public native byte[] getStorageAt(Context ctx, Address account, Hash key, long number) throws Exception;
	/**
	 * GetTransactionByHash returns the transaction with the given hash.
	 */
	public native Transaction getTransactionByHash(Context ctx, Hash hash) throws Exception;
	/**
	 * GetTransactionCount returns the total number of transactions in the given block.
	 */
	public native long getTransactionCount(Context ctx, Hash hash) throws Exception;
	/**
	 * GetTransactionInBlock returns a single transaction at index in the given block.
	 */
	public native Transaction getTransactionInBlock(Context ctx, Hash hash, long index) throws Exception;
	/**
	 * GetTransactionReceipt returns the receipt of a transaction by transaction hash.
	Note that the receipt is not available for pending transactions.
	 */
	public native Receipt getTransactionReceipt(Context ctx, Hash hash) throws Exception;
	/**
	 * GetTransactionSender returns the sender address of a transaction. The transaction must
	be included in blockchain at the given block and index.
	 */
	public native Address getTransactionSender(Context ctx, Transaction tx, Hash blockhash, long index) throws Exception;
	/**
	 * PendingCallContract executes a message call transaction using the EVM.
	The state seen by the contract call is the pending state.
	 */
	public native byte[] pendingCallContract(Context ctx, CallMsg msg) throws Exception;
	/**
	 * SendTransaction injects a signed transaction into the pending pool for execution.
	
	If the transaction was a contract creation use the TransactionReceipt method to get the
	contract address after the transaction has been mined.
	 */
	public native void sendTransaction(Context ctx, Transaction tx) throws Exception;
	/**
	 * SubscribeFilterLogs subscribes to the results of a streaming filter query.
	 */
	public native Subscription subscribeFilterLogs(Context ctx, FilterQuery query, FilterLogsHandler handler, long buffer) throws Exception;
	/**
	 * SubscribeNewHead subscribes to notifications about the current blockchain head
	on the given channel.
	 */
	public native Subscription subscribeNewHead(Context ctx, NewHeadHandler handler, long buffer) throws Exception;
	/**
	 * SuggestGasPrice retrieves the currently suggested gas price to allow a timely
	execution of a transaction.
	 */
	public native BigInt suggestGasPrice(Context ctx) throws Exception;
	/**
	 * SyncProgress retrieves the current progress of the sync algorithm. If there&#39;s
	no sync currently running, it returns nil.
	 */
	public native SyncProgress syncProgress(Context ctx) throws Exception;
	@Override public boolean equals(Object o) {
		if (o == null || !(o instanceof EthereumClient)) {
		    return false;
		}
		EthereumClient that = (EthereumClient)o;
		return true;
	}
	
	@Override public int hashCode() {
	    return java.util.Arrays.hashCode(new Object[] {});
	}
	
	@Override public String toString() {
		StringBuilder b = new StringBuilder();
		b.append("EthereumClient").append("{");
		return b.append("}").toString();
	}
}

